class = function(prototype)
local derived={}

 	if prototype then
		derived.__proto	= prototype
 		function derived.__index(t,key)
 			return rawget(derived,key) or prototype[key]
 		end
 	else
 		function derived.__index(t,key)
 			return rawget(derived,key)
 		end
 	end
 	
 	function derived.__call(proto,...)
 		local instance={}
 		setmetatable(instance,proto)
 		instance.__obj	= true
 		local init=instance.init
 		if init then
 			init(instance,...)
 		end
 		return instance
 	end
 	
 	setmetatable(derived,derived)
 	return derived
end

function string:split(pattern, tms)
	self_type = type(self)
	pattern_type = type(pattern)
	if (self_type ~= 'string' and self_type ~= 'number') then
		buffer = [[bad argument #1 to 'split' (string expected, got ]] .. self_type .. [[)]]
		error(buffer)
	end
	if (pattern_type ~= 'string' and pattern_type ~= 'number' and pattern_type ~= 'nil') then
		buffer = [[bad argument #2 to 'split' (string expected, got ]] .. pattern_type .. [[)]]
		error(buffer)
	end
	
	pattern = pattern or '%s+'
	local start = 1
	local list = {}
	while true do
		local b, e = string.find(self, pattern, start)
		local tm = #list
		if b == nil or tm == tms then	
			list[tm+1] = string.sub(self, start)
			break
		end
		list[tm+1] = string.sub(self, start, b-1)
		start = e + 1
	end
	return list
end


function math.round(n)
	return math.floor(n+.5)
end

-------------------------------
-- String function extension --
-------------------------------

--[[
* Str:devide(pattern)
* string.devide(Str, pattern)

> string : a general string
> pattern: Lua pattern

< Table of strings
--]]

function string:devide(pattern)
	local out = {}
	local sp, ep, ssp, eep = 0, 0, 0, 0
	local len = #self
	local outp = 0
 
	while sp<len do
		ssp, eep = self:find(pattern, ep+1)
		if not ssp then ssp=len+1 end
		if ssp-ep>1 then
			outp = outp + 1
			out[outp] = self:sub(ep+1, ssp-1)
		end
		if eep then
			outp = outp + 1
			out[outp] = self:sub(ssp, eep)
		end
		sp = ssp
		ep = eep
	end
 
	return out
end

