local xml =[[
<?xml version="1.0" encoding="UTF-8" ?>
<prob xmlns="urn:TI.Problem" ver="1.0" pbname="">
	<sym>
		<e t="5" f="65536" c="0">
			<n>%s</n>
			<v>&quot;%s&quot;</v>
		</e>
	</sym>
	<card clay="0" h1="10000" h2="10000" w1="10000" w2="10000">
		<isDummyCard>0</isDummyCard>
		<flag>0</flag>
		
		<wdgt xmlns:sc="urn:TI.ScriptApp" type="TI.ScriptApp" ver="1.0">
			<sc:mFlags>1024</sc:mFlags>
			<sc:value>0</sc:value>
			<sc:script version="512" id="0">
				%s
			</sc:script>		
			<sc:scriptTitle>Data Container</sc:scriptTitle>
		</wdgt>
	</card>
</prob>"
]]

encodeTable = {}
encodeTable["\""] = "&quot;"
encodeTable["'" ] = "&apos;"
encodeTable["&" ] = "&amp;"
encodeTable["<" ] = "&lt;"
encodeTable[">" ] = "&gt;"

function encode(str, double)
	local l = str:gsub("[\"'&<>]", encodeTable)
	if double then
		l = l:gsub("&quot;","&quot;&quot;")
	end
	return l
end

function genXML(data, varname, luascript)
	data      = data      or ""
	varname   = varname   or "test"
	luascript = luascript or ""
	
	return xml:format(encode(varname),encode(data, true), encode(luascript))
end

local cachefile = assert(io.open("cache.http", "r"), "Could not open cache.http")
local filecontent = cachefile:read("*a")
cachefile:close()

local data = genXML(filecontent, "cache", "function on.paint(gc) gc:drawString(\"This is a cache file, nothing to do here ;)\",10,10,\"top\") end")
local tmpfile = assert(io.open("cache.xml", "w"), "Failed to create temp file. Are you sure you have permissions to the current directory ?")
tmpfile:write(data)
tmpfile:close()

os.exit(os.execute("luna cache.xml cache.tns"))
